Index: /LMDZ4/branches/LMDZ4-dev/libf/dyn3d/infotrac.F90
===================================================================
--- /LMDZ4/branches/LMDZ4-dev/libf/dyn3d/infotrac.F90	(revision 1190)
+++ /LMDZ4/branches/LMDZ4-dev/libf/dyn3d/infotrac.F90	(revision 1191)
@@ -21,8 +21,11 @@
   INTEGER, ALLOCATABLE, DIMENSION(:), SAVE    :: niadv ! equivalent dyn / physique
 
-! Variables for INCA
+! conv_flg(it)=0 : convection desactivated for tracer number it 
   INTEGER, ALLOCATABLE, DIMENSION(:), SAVE  :: conv_flg
+! pbl_flg(it)=0  : boundary layer diffusion desactivaded for tracer number it 
   INTEGER, ALLOCATABLE, DIMENSION(:), SAVE  :: pbl_flg
 
+  CHARACTER(len=4),SAVE :: type_trac
+ 
 CONTAINS
 
@@ -80,4 +83,11 @@
     descrq(20)='SLP'
     descrq(30)='PRA'
+    
+
+    IF (config_inca=='none') THEN
+       type_trac='lmdz'
+    ELSE
+       type_trac='inca'
+    END IF
 
 !-----------------------------------------------------------------------
@@ -87,5 +97,5 @@
 !
 !-----------------------------------------------------------------------
-    IF (config_inca == 'none') THEN
+    IF (type_trac == 'lmdz') THEN
        OPEN(90,file='traceur.def',form='formatted',status='old', iostat=ierr)
        IF(ierr.EQ.0) THEN
@@ -109,13 +119,11 @@
     END IF
 !
-! Allocate variables depending on nqtrue
+! Allocate variables depending on nqtrue and nbtr
 !
     ALLOCATE(tnom_0(nqtrue), hadv(nqtrue), vadv(nqtrue))
-
-    IF (config_inca /= 'none') THEN
-       ! Varaibles only needed in case of INCA
-       ALLOCATE(conv_flg(nbtr), pbl_flg(nbtr), tracnam(nbtr))
-    END IF
-       
+    ALLOCATE(conv_flg(nbtr), pbl_flg(nbtr), tracnam(nbtr))
+    conv_flg(:) = 1 ! convection activated for all tracers
+    pbl_flg(:)  = 1 ! boundary layer activated for all tracers
+
 !-----------------------------------------------------------------------
 ! 2)     Choix  des schemas d'advection pour l'eau et les traceurs
@@ -144,5 +152,5 @@
 !    Get choice of advection schema from file tracer.def or from INCA
 !---------------------------------------------------------------------
-    IF (config_inca == 'none') THEN
+    IF (type_trac == 'lmdz') THEN
        IF(ierr.EQ.0) THEN
           ! Continue to read tracer.def
@@ -172,5 +180,5 @@
        END DO
 
-    ELSE  ! config_inca='aero' ou 'chem'
+    ELSE  ! type_trac=inca : config_inca='aero' ou 'chem'
 ! le module de chimie fournit les noms des traceurs
 ! et les schemas d'advection associes.
@@ -191,5 +199,5 @@
        END DO
 
-    END IF ! config_inca
+    END IF ! type_trac
 
 !-----------------------------------------------------------------------
@@ -319,5 +327,5 @@
 !
     DEALLOCATE(tnom_0, hadv, vadv)
-    IF (config_inca /= 'none') DEALLOCATE(tracnam)
+    DEALLOCATE(tracnam)
 
 999 FORMAT (i2,1x,i2,1x,a8)
Index: /LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/infotrac.F90
===================================================================
--- /LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/infotrac.F90	(revision 1190)
+++ /LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/infotrac.F90	(revision 1191)
@@ -21,8 +21,11 @@
   INTEGER, ALLOCATABLE, DIMENSION(:), SAVE    :: niadv ! equivalent dyn / physique
 
-! Variables for INCA
+! conv_flg(it)=0 : convection desactivated for tracer number it 
   INTEGER, ALLOCATABLE, DIMENSION(:), SAVE  :: conv_flg
+! pbl_flg(it)=0  : boundary layer diffusion desactivaded for tracer number it 
   INTEGER, ALLOCATABLE, DIMENSION(:), SAVE  :: pbl_flg
 
+  CHARACTER(len=4),SAVE :: type_trac
+ 
 CONTAINS
 
@@ -80,4 +83,11 @@
     descrq(20)='SLP'
     descrq(30)='PRA'
+    
+
+    IF (config_inca=='none') THEN
+       type_trac='lmdz'
+    ELSE
+       type_trac='inca'
+    END IF
 
 !-----------------------------------------------------------------------
@@ -87,5 +97,5 @@
 !
 !-----------------------------------------------------------------------
-    IF (config_inca == 'none') THEN
+    IF (type_trac == 'lmdz') THEN
        OPEN(90,file='traceur.def',form='formatted',status='old', iostat=ierr)
        IF(ierr.EQ.0) THEN
@@ -109,13 +119,11 @@
     END IF
 !
-! Allocate variables depending on nqtrue
+! Allocate variables depending on nqtrue and nbtr
 !
     ALLOCATE(tnom_0(nqtrue), hadv(nqtrue), vadv(nqtrue))
-
-    IF (config_inca /= 'none') THEN
-       ! Varaibles only needed in case of INCA
-       ALLOCATE(conv_flg(nbtr), pbl_flg(nbtr), tracnam(nbtr))
-    END IF
-       
+    ALLOCATE(conv_flg(nbtr), pbl_flg(nbtr), tracnam(nbtr))
+    conv_flg(:) = 1 ! convection activated for all tracers
+    pbl_flg(:)  = 1 ! boundary layer activated for all tracers
+
 !-----------------------------------------------------------------------
 ! 2)     Choix  des schemas d'advection pour l'eau et les traceurs
@@ -144,5 +152,5 @@
 !    Get choice of advection schema from file tracer.def or from INCA
 !---------------------------------------------------------------------
-    IF (config_inca == 'none') THEN
+    IF (type_trac == 'lmdz') THEN
        IF(ierr.EQ.0) THEN
           ! Continue to read tracer.def
@@ -172,5 +180,5 @@
        END DO
 
-    ELSE  ! config_inca='aero' ou 'chem'
+    ELSE  ! type_trac=inca : config_inca='aero' ou 'chem'
 ! le module de chimie fournit les noms des traceurs
 ! et les schemas d'advection associes.
@@ -191,5 +199,5 @@
        END DO
 
-    END IF ! config_inca
+    END IF ! type_trac
 
 !-----------------------------------------------------------------------
@@ -319,5 +327,5 @@
 !
     DEALLOCATE(tnom_0, hadv, vadv)
-    IF (config_inca /= 'none') DEALLOCATE(tracnam)
+    DEALLOCATE(tracnam)
 
 999 FORMAT (i2,1x,i2,1x,a8)
Index: /LMDZ4/branches/LMDZ4-dev/libf/phylmd/YOECUMF.h
===================================================================
--- /LMDZ4/branches/LMDZ4-dev/libf/phylmd/YOECUMF.h	(revision 1190)
+++ /LMDZ4/branches/LMDZ4-dev/libf/phylmd/YOECUMF.h	(revision 1191)
@@ -1,43 +1,48 @@
 !
-! $Header$
+! $Id$
 !
-C     ----------------------------------------------------------------
-C*    *COMMON* *YOECUMF* - PARAMETERS FOR CUMULUS MASSFLUX SCHEME
-C     ----------------------------------------------------------------
-C
-      COMMON /YOECUMF/
-     L                 LMFPEN,LMFSCV,LMFMID,LMFDD,LMFDUDV,
-     R                 ENTRPEN,ENTRSCV,ENTRMID,ENTRDD,CMFCTOP,
-     R                 CMFCMAX,CMFCMIN,CMFDEPS,RHCDD,CPRCON
-C
+!  ATTENTION!!!!: ce fichier include est compatible format fixe/format libre
+!                 veillez n'utiliser que des ! pour les commentaires
+!                 et bien positionner les & des lignes de continuation
+!                 (les placer en colonne 6 et en colonne 73)
+!
+!     ----------------------------------------------------------------
+!*    *COMMON* *YOECUMF* - PARAMETERS FOR CUMULUS MASSFLUX SCHEME
+!     ----------------------------------------------------------------
+!
+      COMMON /YOECUMF/                                                  &
+     &                 LMFPEN,LMFSCV,LMFMID,LMFDD,LMFDUDV,              &
+     &                 ENTRPEN,ENTRSCV,ENTRMID,ENTRDD,CMFCTOP,          &
+     &                 CMFCMAX,CMFCMIN,CMFDEPS,RHCDD,CPRCON
+
       LOGICAL          LMFPEN,LMFSCV,LMFMID,LMFDD,LMFDUDV
       REAL ENTRPEN, ENTRSCV, ENTRMID, ENTRDD
       REAL CMFCTOP, CMFCMAX, CMFCMIN, CMFDEPS, RHCDD, CPRCON
-c$OMP THREADPRIVATE(/YOECUMF/)
-C
-*if (DOC,declared) <> 'UNKNOWN'
-C*    *COMMON* *YOECUMF* - PARAMETERS FOR CUMULUS MASSFLUX SCHEME
-C
-C     M.TIEDTKE       E. C. M. W. F.      18/1/89
-C
-C     NAME      TYPE      PURPOSE
-C     ----      ----      -------
-C
-C     LMFPEN    LOGICAL  TRUE IF PENETRATIVE CONVECTION IS SWITCHED ON
-C     LMFSCV    LOGICAL  TRUE IF SHALLOW     CONVECTION IS SWITCHED ON
-C     LMFMID    LOGICAL  TRUE IF MIDLEVEL    CONVECTION IS SWITCHED ON
-C     LMFDD     LOGICAL  TRUE IF CUMULUS DOWNDRAFT      IS SWITCHED ON
-C     LMFDUDV   LOGICAL  TRUE IF CUMULUS FRICTION       IS SWITCHED ON
-C     ENTRPEN   REAL     ENTRAINMENT RATE FOR PENETRATIVE CONVECTION
-C     ENTRSCV   REAL     ENTRAINMENT RATE FOR SHALLOW CONVECTION
-C     ENTRMID   REAL     ENTRAINMENT RATE FOR MIDLEVEL CONVECTION
-C     ENTRDD    REAL     ENTRAINMENT RATE FOR CUMULUS DOWNDRAFTS
-C     CMFCTOP   REAL     RELAT. CLOUD MASSFLUX AT LEVEL ABOVE NONBUOYANC
-C     CMFCMAX   REAL     MAXIMUM MASSFLUX VALUE ALLOWED FOR
-C     CMFCMIN   REAL     MINIMUM MASSFLUX VALUE (FOR SAFETY)
-C     CMFDEPS   REAL     FRACTIONAL MASSFLUX FOR DOWNDRAFTS AT LFS
-C     RHCDD     REAL     RELATIVE SATURATION IN DOWNDRAFTS
-C     CPRCON    REAL     COEFFICIENTS FOR DETERMINING CONVERSION
-C                        FROM CLOUD WATER TO RAIN
-*ifend
-C     ----------------------------------------------------------------
+!$OMP THREADPRIVATE(/YOECUMF/)
+!
+!*if (DOC,declared) <> 'UNKNOWN'
+!*    *COMMON* *YOECUMF* - PARAMETERS FOR CUMULUS MASSFLUX SCHEME
+!
+!     M.TIEDTKE       E. C. M. W. F.      18/1/89
+!
+!     NAME      TYPE      PURPOSE
+!     ----      ----      -------
+!
+!     LMFPEN    LOGICAL  TRUE IF PENETRATIVE CONVECTION IS SWITCHED ON
+!     LMFSCV    LOGICAL  TRUE IF SHALLOW     CONVECTION IS SWITCHED ON
+!     LMFMID    LOGICAL  TRUE IF MIDLEVEL    CONVECTION IS SWITCHED ON
+!     LMFDD     LOGICAL  TRUE IF CUMULUS DOWNDRAFT      IS SWITCHED ON
+!     LMFDUDV   LOGICAL  TRUE IF CUMULUS FRICTION       IS SWITCHED ON
+!     ENTRPEN   REAL     ENTRAINMENT RATE FOR PENETRATIVE CONVECTION
+!     ENTRSCV   REAL     ENTRAINMENT RATE FOR SHALLOW CONVECTION
+!     ENTRMID   REAL     ENTRAINMENT RATE FOR MIDLEVEL CONVECTION
+!     ENTRDD    REAL     ENTRAINMENT RATE FOR CUMULUS DOWNDRAFTS
+!     CMFCTOP   REAL     RELAT. CLOUD MASSFLUX AT LEVEL ABOVE NONBUOYANC
+!     CMFCMAX   REAL     MAXIMUM MASSFLUX VALUE ALLOWED FOR
+!     CMFCMIN   REAL     MINIMUM MASSFLUX VALUE (FOR SAFETY)
+!     CMFDEPS   REAL     FRACTIONAL MASSFLUX FOR DOWNDRAFTS AT LFS
+!     RHCDD     REAL     RELATIVE SATURATION IN DOWNDRAFTS
+!     CPRCON    REAL     COEFFICIENTS FOR DETERMINING CONVERSION
+!                        FROM CLOUD WATER TO RAIN
+!*ifend
+!     ----------------------------------------------------------------
Index: /LMDZ4/branches/LMDZ4-dev/libf/phylmd/cltrac.F90
===================================================================
--- /LMDZ4/branches/LMDZ4-dev/libf/phylmd/cltrac.F90	(revision 1191)
+++ /LMDZ4/branches/LMDZ4-dev/libf/phylmd/cltrac.F90	(revision 1191)
@@ -0,0 +1,140 @@
+!
+! $Id $
+!
+SUBROUTINE cltrac(dtime,coef,t,tr,flux,paprs,pplay,delp,d_tr)
+  USE dimphy
+  IMPLICIT NONE
+!======================================================================
+! Auteur(s): O. Boucher (LOA/LMD) date: 19961127
+!            inspire de clvent
+! Objet: diffusion verticale de traceurs avec flux fixe a la surface
+!        ou/et flux du type c-drag
+!
+! Arguments:
+!-----------
+! dtime....input-R- intervalle du temps (en secondes)
+! coef.....input-R- le coefficient d'echange (m**2/s) l>1
+! t........input-R- temperature (K)
+! tr.......input-R- la q. de traceurs
+! flux.....input-R- le flux de traceurs a la surface
+! paprs....input-R- pression a inter-couche (Pa)
+! pplay....input-R- pression au milieu de couche (Pa)
+! delp.....input-R- epaisseur de couche (Pa)
+! cdrag....input-R- cdrag pour le flux de surface (non active)
+! tr0......input-R- traceurs a la surface ou dans l'ocean (non active)
+! d_tr.....output-R- le changement de tr
+! flux_tr..output-R- flux de tr
+!======================================================================
+  include "YOMCST.h"
+!
+! Entree
+! 
+  REAL,INTENT(IN)                        :: dtime
+  REAL,DIMENSION(klon,klev),INTENT(IN)   :: coef
+  REAL,DIMENSION(klon,klev),INTENT(IN)   :: t, tr
+  REAL,DIMENSION(klon),INTENT(IN)        :: flux !(at/s/m2)
+  REAL,DIMENSION(klon,klev+1),INTENT(IN) :: paprs 
+  REAL,DIMENSION(klon,klev),INTENT(IN)   :: pplay, delp
+!
+! Sorties
+!
+  REAL ,DIMENSION(klon,klev),INTENT(OUT) :: d_tr
+!  REAL ,DIMENSION(klon,klev),INTENT(OUT) :: flux_tr
+!
+! Local
+! 
+  INTEGER                   :: i, k
+  REAL,DIMENSION(klon)      :: cdrag, tr0
+  REAL,DIMENSION(klon,klev) :: zx_ctr
+  REAL,DIMENSION(klon,klev) :: zx_dtr
+  REAL,DIMENSION(klon)      :: zx_buf
+  REAL,DIMENSION(klon,klev) :: zx_coef
+  REAL,DIMENSION(klon,klev) :: local_tr
+  REAL,DIMENSION(klon)      :: zx_alf1,zx_alf2,zx_flux
+
+!======================================================================
+
+  DO k = 1, klev
+     DO i = 1, klon
+        local_tr(i,k) = tr(i,k)
+     ENDDO
+  ENDDO
+
+!======================================================================
+
+  DO i = 1, klon
+     zx_alf1(i) = (paprs(i,1)-pplay(i,2))/(pplay(i,1)-pplay(i,2))
+     zx_alf2(i) = 1.0 - zx_alf1(i)
+     zx_flux(i) =  -flux(i)*dtime*RG
+! Pour le moment le flux est prescrit cdrag et zx_coef(1) vaut 0
+     cdrag(i) = 0.0 
+     tr0(i) = 0.0
+     zx_coef(i,1) = cdrag(i)*dtime*RG 
+     zx_ctr(i,1)=0.
+     zx_dtr(i,1)=0.
+  ENDDO
+
+!======================================================================
+
+  DO k = 2, klev
+     DO i = 1, klon
+        zx_coef(i,k) = coef(i,k)*RG/(pplay(i,k-1)-pplay(i,k))   &
+             *(paprs(i,k)*2/(t(i,k)+t(i,k-1))/RD)**2
+        zx_coef(i,k) = zx_coef(i,k)*dtime*RG  
+     ENDDO
+  ENDDO
+
+!======================================================================
+
+  DO i = 1, klon
+     zx_buf(i) = delp(i,1) + zx_coef(i,1)*zx_alf1(i) + zx_coef(i,2)
+     !
+     zx_ctr(i,2) = (local_tr(i,1)*delp(i,1)+                  &
+          zx_coef(i,1)*tr0(i)-zx_flux(i))/zx_buf(i)
+     !
+     zx_dtr(i,2) = (zx_coef(i,2)-zx_alf2(i)*zx_coef(i,1)) /   & 
+          zx_buf(i)
+  ENDDO
+
+  DO k = 3, klev
+     DO i = 1, klon
+        zx_buf(i) = delp(i,k-1) + zx_coef(i,k)      &
+             + zx_coef(i,k-1)*(1.-zx_dtr(i,k-1))
+        zx_ctr(i,k) = (local_tr(i,k-1)*delp(i,k-1)  & 
+             +zx_coef(i,k-1)*zx_ctr(i,k-1) )/zx_buf(i)
+        zx_dtr(i,k) = zx_coef(i,k)/zx_buf(i)
+     ENDDO
+  ENDDO
+
+  DO i = 1, klon
+     local_tr(i,klev) = ( local_tr(i,klev)*delp(i,klev) &
+          +zx_coef(i,klev)*zx_ctr(i,klev) )             &
+          / ( delp(i,klev) + zx_coef(i,klev)            &
+          -zx_coef(i,klev)*zx_dtr(i,klev) )
+  ENDDO
+
+  DO k = klev-1, 1, -1
+     DO i = 1, klon
+        local_tr(i,k) = zx_ctr(i,k+1) + zx_dtr(i,k+1)*local_tr(i,k+1)
+     ENDDO
+  ENDDO
+
+!======================================================================
+!== flux_tr est le flux de traceur (positif vers bas)
+!      DO i = 1, klon
+!         flux_tr(i,1) = zx_coef(i,1)/(RG*dtime)
+!      ENDDO
+!      DO k = 2, klev
+!      DO i = 1, klon
+!         flux_tr(i,k) = zx_coef(i,k)/(RG*dtime)
+!     .               * (local_tr(i,k)-local_tr(i,k-1))
+!      ENDDO
+!      ENDDO
+!======================================================================
+  DO k = 1, klev
+     DO i = 1, klon
+        d_tr(i,k) = local_tr(i,k) - tr(i,k)
+     ENDDO
+  ENDDO
+  
+END SUBROUTINE cltrac
Index: /LMDZ4/branches/LMDZ4-dev/libf/phylmd/cltracrn.F90
===================================================================
--- /LMDZ4/branches/LMDZ4-dev/libf/phylmd/cltracrn.F90	(revision 1191)
+++ /LMDZ4/branches/LMDZ4-dev/libf/phylmd/cltracrn.F90	(revision 1191)
@@ -0,0 +1,286 @@
+!$Id $
+
+SUBROUTINE cltracrn( itr, dtime,u1lay, v1lay, &
+     cdrag,coef,t,ftsol,pctsrf,               &
+     tr,trs,paprs,pplay,delp,                 &
+     masktr,fshtr,hsoltr,tautr,vdeptr,        &
+     lat,d_tr,d_trs )
+  
+  USE dimphy
+  IMPLICIT NONE
+!======================================================================
+! Auteur(s): Alex/LMD) date:  fev 99
+!            inspire de clqh + clvent
+! Objet: diffusion verticale de traceurs avec quantite de traceur ds 
+!        le sol ( reservoir de sol de radon ) 
+!        
+! note : pour l'instant le traceur dans le sol et le flux sont
+!        calcules mais ils ne servent que de diagnostiques
+!        seule la tendance sur le traceur est sortie (d_tr)
+!---------------------------------------------------------------------
+! Arguments:
+! itr......input-R-  le type de traceur 1- Rn 2 - Pb
+! dtime....input-R-  intervalle du temps (en secondes) ~ pdtphys
+! u1lay....input-R-  vent u de la premiere couche (m/s)
+! v1lay....input-R-  vent v de la premiere couche (m/s)
+! cdrag....input-R-  cdrag
+! coef.....input-R-  le coefficient d'echange (m**2/s) l>1, valable uniquement pour k entre 2 et klev
+! t........input-R-  temperature (K)
+! paprs....input-R-  pression a inter-couche (Pa)
+! pplay....input-R-  pression au milieu de couche (Pa)
+! delp.....input-R-  epaisseur de couche (Pa)
+! ftsol....input-R-  temperature du sol (en Kelvin)
+! tr.......input-R-  traceurs
+! trs......input-R-  traceurs dans le sol
+! masktr...input-R-  Masque reservoir de sol traceur (1 = reservoir)
+! fshtr....input-R-  Flux surfacique de production dans le sol
+! tautr....input-R-  Constante de decroissance du traceur
+! vdeptr...input-R-  Vitesse de depot sec dans la couche brownienne
+! hsoltr...input-R-  Epaisseur equivalente du reservoir de sol
+! lat......input-R-  latitude en degree
+! d_tr.....output-R- le changement de "tr"
+! d_trs....output-R- le changement de "trs"
+!======================================================================
+  include "YOMCST.h"
+  include "indicesol.h"
+!
+!Entrees
+  INTEGER,INTENT(IN)                     :: itr
+  REAL,INTENT(IN)                        :: dtime
+  REAL,DIMENSION(klon),INTENT(IN)        :: u1lay, v1lay
+  REAL,DIMENSION(klon),INTENT(IN)        :: cdrag
+  REAL,DIMENSION(klon,klev),INTENT(IN)   :: coef, t
+  REAL,DIMENSION(klon,nbsrf),INTENT(IN)  :: ftsol, pctsrf 
+  REAL,DIMENSION(klon,klev),INTENT(IN)   :: tr 
+  REAL,DIMENSION(klon),INTENT(IN)        :: trs
+  REAL,DIMENSION(klon,klev+1),INTENT(IN) :: paprs 
+  REAL,DIMENSION(klon,klev),INTENT(IN)   :: pplay, delp
+  REAL,DIMENSION(klon),INTENT(IN)        :: masktr 
+  REAL,DIMENSION(klon),INTENT(IN)        :: fshtr 
+  REAL,INTENT(IN)                        :: hsoltr
+  REAL,INTENT(IN)                        :: tautr
+  REAL,INTENT(IN)                        :: vdeptr
+  REAL,DIMENSION(klon),INTENT(IN)        :: lat   
+
+!Sorties
+  REAL,DIMENSION(klon,klev),INTENT(OUT) :: d_tr
+  REAL,DIMENSION(klon),INTENT(OUT) :: d_trs  ! (diagnostic) traceur ds le sol
+
+!Locales
+  REAL,DIMENSION(klon,klev) :: flux_tr  ! (diagnostic) flux de traceur
+  INTEGER                   :: i, k, n, l
+  REAL,DIMENSION(klon)      :: rotrhi
+  REAL,DIMENSION(klon,klev) :: zx_coef
+  REAL,DIMENSION(klon)      :: zx_buf
+  REAL,DIMENSION(klon,klev) :: zx_ctr
+  REAL,DIMENSION(klon,klev) :: zx_dtr
+  REAL,DIMENSION(klon)      :: zx_trs
+  REAL                      :: zx_a, zx_b
+  
+  REAL,DIMENSION(klon,klev) :: local_tr
+  REAL,DIMENSION(klon)      :: local_trs
+  REAL,DIMENSION(klon)      :: zts      ! champ de temperature du sol
+  REAL,DIMENSION(klon)      :: zx_alpha1, zx_alpha2
+!======================================================================
+!AA Pour l'instant les 4 types de surface ne sont pas pris en compte
+!AA On fabrique avec zts un champ de temperature de sol  
+!AA que le pondere par la fraction de nature de sol.
+ 
+  DO i = 1,klon
+     zts(i) = 0. 
+  ENDDO
+
+  DO n=1,nbsrf
+     DO i = 1,klon
+        zts(i) = zts(i) + ftsol(i,n)*pctsrf(i,n)
+     ENDDO
+  ENDDO
+
+  DO i = 1,klon
+     rotrhi(i) = RD * zts(i) / hsoltr 
+  ENDDO
+
+  DO k = 1, klev
+     DO i = 1, klon
+        local_tr(i,k) = tr(i,k)
+     ENDDO
+  ENDDO
+
+  DO i = 1, klon
+     local_trs(i) = trs(i)
+  ENDDO
+!======================================================================
+!AA   Attention si dans clmain zx_alf1(i) = 1.0 
+!AA   Il doit y avoir coherence (dc la meme chose ici)
+
+  DO i = 1, klon
+!AA         zx_alpha1(i) = (paprs(i,1)-pplay(i,2))/(pplay(i,1)-pplay(i,2))
+     zx_alpha1(i) = 1.0
+     zx_alpha2(i) = 1.0 - zx_alpha1(i)
+  ENDDO
+!======================================================================
+  DO i = 1, klon
+     zx_coef(i,1) = cdrag(i)*(1.0+SQRT(u1lay(i)**2+v1lay(i)**2)) &
+          *pplay(i,1)/(RD*t(i,1))
+     zx_coef(i,1) = zx_coef(i,1) * dtime*RG
+  ENDDO
+
+  DO k = 2, klev
+     DO i = 1, klon
+        zx_coef(i,k) = coef(i,k)*RG/(pplay(i,k-1)-pplay(i,k)) &
+             *(paprs(i,k)*2/(t(i,k)+t(i,k-1))/RD)**2
+        zx_coef(i,k) = zx_coef(i,k) * dtime*RG
+     ENDDO
+  ENDDO
+!======================================================================
+  DO i = 1, klon
+     zx_buf(i)      = delp(i,klev) + zx_coef(i,klev)
+     zx_ctr(i,klev) = local_tr(i,klev)*delp(i,klev)/zx_buf(i)
+     zx_dtr(i,klev) = zx_coef(i,klev) / zx_buf(i)
+  ENDDO
+
+  DO l = klev-1, 2 , -1
+     DO i = 1, klon
+        zx_buf(i) = delp(i,l)+zx_coef(i,l)      &
+             +zx_coef(i,l+1)*(1.-zx_dtr(i,l+1))
+ 
+        zx_ctr(i,l) = ( local_tr(i,l)*delp(i,l) &
+             + zx_coef(i,l+1)*zx_ctr(i,l+1) )/zx_buf(i)
+        zx_dtr(i,l) = zx_coef(i,l) / zx_buf(i)
+     ENDDO
+  ENDDO
+
+  DO i = 1, klon
+     zx_buf(i) = delp(i,1) + zx_coef(i,2)*(1.-zx_dtr(i,2))  &
+          + masktr(i) * zx_coef(i,1)                        &
+          *( zx_alpha1(i)+zx_alpha2(i)*zx_dtr(i,2) )
+
+     zx_ctr(i,1) = ( local_tr(i,1)*delp(i,1)                &
+          + zx_ctr(i,2)                                     &
+          *(zx_coef(i,2)                                    &
+          - masktr(i) * zx_coef(i,1)                        &
+          *zx_alpha2(i) ) ) / zx_buf(i)
+     zx_dtr(i,1) = masktr(i) * zx_coef(i,1) / zx_buf(i)
+  ENDDO
+!======================================================================
+! Calculer d'abord local_trs nouvelle quantite dans le reservoir
+! de sol
+!=====================================================================
+
+  DO i = 1, klon
+!-------------------------
+! Au dessus des continents
+!--
+! Le pb peut se deposer partout : vdeptr = 10-3 m/s
+! Le Rn est traiter commme une couche Brownienne puisque vdeptr = 0.
+!-------------------------------------------------------------------
+     IF ( NINT(masktr(i)) .EQ. 1 ) THEN
+        zx_trs(i) = local_trs(i)
+        zx_a = zx_trs(i)                                           &
+             +fshtr(i)*dtime*rotrhi(i)                             &
+             +rotrhi(i)*masktr(i)*zx_coef(i,1)/RG                  &
+             *(zx_ctr(i,1)*(zx_alpha1(i)+zx_alpha2(i)*zx_dtr(i,2)) &
+             +zx_alpha2(i)*zx_ctr(i,2))
+! Pour l'instant, pour aller vite, le depot sec est traite comme une decroissance
+        zx_b = 1. + rotrhi(i)*masktr(i)*zx_coef(i,1)/RG            &
+             * (1.-zx_dtr(i,1)                                     &
+             *(zx_alpha1(i)+zx_alpha2(i)*zx_dtr(i,2)))             &
+             + dtime / tautr                                       & 
+             + dtime * vdeptr / hsoltr 
+        zx_trs(i) = zx_a / zx_b
+        local_trs(i) = zx_trs(i)
+     ENDIF
+!--------------------------------------------------------
+! Si on est entre 60N et 70N on divise par 2 l'emanation
+!--------------------------------------------------------
+
+     IF ( (itr.eq.1.AND.NINT(masktr(i)).EQ.1.AND.lat(i).GE.60..AND.lat(i).LE.70.).OR.      &
+          (itr.eq.2.AND.NINT(masktr(i)).EQ.1.AND.lat(i).GE.60..AND.lat(i).LE.70.) ) THEN
+        zx_trs(i) = local_trs(i)
+        zx_a = zx_trs(i)                                           &
+             +(fshtr(i)/2.)*dtime*rotrhi(i)                        & 
+             +rotrhi(i)*masktr(i)*zx_coef(i,1)/RG                  &
+             *(zx_ctr(i,1)*(zx_alpha1(i)+zx_alpha2(i)*zx_dtr(i,2)) &
+             +zx_alpha2(i)*zx_ctr(i,2))
+        !
+        zx_b = 1. + rotrhi(i)*masktr(i)*zx_coef(i,1)/RG  &
+             * (1.-zx_dtr(i,1)                           &
+             *(zx_alpha1(i)+zx_alpha2(i)*zx_dtr(i,2)))   &
+             + dtime / tautr                             &
+             + dtime * vdeptr / hsoltr
+        ! 
+        zx_trs(i) = zx_a / zx_b
+        local_trs(i) = zx_trs(i)
+     ENDIF
+
+!----------------------------------------------
+! Au dessus des oceans et aux hautes latitudes
+!--
+! au dessous de -60S  pas d'emission de radon au dessus 
+! des oceans et des continents
+!---------------------------------------------------------------
+
+     IF ( (itr.EQ.1.AND.NINT(masktr(i)).EQ.0).OR.       &
+          (itr.EQ.1.AND.NINT(masktr(i)).EQ.1.AND.lat(i).LT.-60.)) THEN
+        zx_trs(i) = 0.
+        local_trs(i) = 0.
+     END IF
+!--
+! au dessus de 70 N pas d'emission de radon au dessus 
+! des oceans et des continents
+!--------------------------------------------------------------
+     IF ( (itr.EQ.1.AND.NINT(masktr(i)).EQ.0).OR.    &
+          (itr.EQ.1.AND.NINT(masktr(i)).EQ.1.AND.lat(i).GT.70.)) THEN
+        zx_trs(i) = 0.
+        local_trs(i) = 0.
+     END IF
+!---------------------------------------------
+! Au dessus des oceans la source est nulle
+!--------------------------------------------
+
+     IF (itr.eq.1.AND.NINT(masktr(i)).EQ.0) THEN
+        zx_trs(i) = 0.
+        local_trs(i) = 0.
+     END IF
+
+  ENDDO    ! sur le i=1,klon
+!
+!======================================================================
+! Une fois on a zx_trs, on peut faire l'iteration 
+!====================================================================== 
+
+  DO i = 1, klon
+     local_tr(i,1) = zx_ctr(i,1)+zx_dtr(i,1)*zx_trs(i)
+  ENDDO
+  DO l = 2, klev
+     DO i = 1, klon
+        local_tr(i,l) = zx_ctr(i,l) + zx_dtr(i,l)*local_tr(i,l-1)
+     ENDDO
+  ENDDO
+!======================================================================
+! Calcul du flux de traceur (flux_tr): UA/(m**2 s)
+!======================================================================
+  DO i = 1, klon
+     flux_tr(i,1) = masktr(i)*zx_coef(i,1)/RG                      &
+          * (zx_alpha1(i)*local_tr(i,1)+zx_alpha2(i)*local_tr(i,2) &
+          -zx_trs(i)) / dtime
+  ENDDO
+  DO l = 2, klev
+     DO i = 1, klon
+        flux_tr(i,l) = zx_coef(i,l)/RG                    &
+             * (local_tr(i,l)-local_tr(i,l-1)) / dtime
+     ENDDO
+  ENDDO
+!======================================================================
+! Calcul des tendances du traceur ds le sol et dans l'atmosphere
+!======================================================================
+  DO l = 1, klev
+     DO i = 1, klon
+        d_tr(i,l) = local_tr(i,l) - tr(i,l)
+     ENDDO
+  ENDDO
+  DO i = 1, klon
+     d_trs(i) = local_trs(i) - trs(i)
+  ENDDO
+
+END SUBROUTINE cltracrn
Index: /LMDZ4/branches/LMDZ4-dev/libf/phylmd/cvltr.F90
===================================================================
--- /LMDZ4/branches/LMDZ4-dev/libf/phylmd/cvltr.F90	(revision 1191)
+++ /LMDZ4/branches/LMDZ4-dev/libf/phylmd/cvltr.F90	(revision 1191)
@@ -0,0 +1,145 @@
+!
+! $Id $
+!
+SUBROUTINE cvltr(pdtime,da, phi, mp,paprs,pplay,x,upd,dnd,dx)
+  USE dimphy
+  IMPLICIT NONE 
+!=====================================================================
+! Objet : convection des traceurs / KE
+! Auteurs: M-A Filiberti and J-Y Grandpeix
+!=====================================================================
+
+  include "YOMCST.h"
+  include "YOECUMF.h" 
+
+! Entree
+  REAL,INTENT(IN)                           :: pdtime
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: da
+  REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: phi
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: mp
+  REAL,DIMENSION(klon,klev+1),INTENT(IN)    :: paprs ! pression aux 1/2 couches (bas en haut)
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: pplay ! pression pour le milieu de chaque couche
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: x     ! q de traceur (bas en haut) 
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: upd   ! saturated updraft mass flux
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: dnd   ! saturated downdraft mass flux
+
+! Sortie
+  REAL,DIMENSION(klon,klev),INTENT(OUT) :: dx ! tendance de traceur  (bas en haut)
+
+! Variables locales     
+  REAL,DIMENSION(klon,klev)       :: zed
+  REAL,DIMENSION(klon,klev,klev)  :: zmd
+  REAL,DIMENSION(klon,klev,klev)  :: za
+  REAL,DIMENSION(klon,klev)       :: zmfd,zmfa
+  REAL,DIMENSION(klon,klev)       :: zmfp,zmfu
+  INTEGER                         :: i,k,j 
+
+! =========================================
+! calcul des tendances liees au downdraft
+! =========================================
+  zed(:,:)=0.
+  zmfd(:,:)=0.
+  zmfa(:,:)=0.
+  zmfu(:,:)=0.
+  zmfp(:,:)=0.
+  zmd(:,:,:)=0.
+  za(:,:,:)=0.
+! entrainement
+  DO k=1,klev-1
+     DO i=1,klon
+        zed(i,k)=max(0.,mp(i,k)-mp(i,k+1))
+     END DO
+  END DO
+
+! calcul de la matrice d echange
+! matrice de distribution de la masse entrainee en k
+
+  DO k=1,klev
+     DO i=1,klon
+        zmd(i,k,k)=zed(i,k)
+     END DO
+  END DO
+  DO k=2,klev
+     DO j=k-1,1,-1
+        DO i=1,klon
+           if(mp(i,j+1).ne.0) then
+              zmd(i,j,k)=zmd(i,j+1,k)*min(1.,mp(i,j)/mp(i,j+1))
+           ENDif
+        END DO
+     END DO
+  END DO
+  DO k=1,klev
+     DO j=1,klev-1
+        DO i=1,klon
+           za(i,j,k)=max(0.,zmd(i,j+1,k)-zmd(i,j,k))
+        END DO
+     END DO
+  END DO
+!
+! rajout du terme lie a l ascendance induite
+!
+  DO j=2,klev
+     DO i=1,klon
+        za(i,j,j-1)=za(i,j,j-1)+mp(i,j)
+     END DO
+  END DO
+!
+! tendances
+!            
+  DO k=1,klev
+     DO j=1,klev
+        DO i=1,klon
+           zmfd(i,j)=zmfd(i,j)+za(i,j,k)*(x(i,k)-x(i,j))
+        END DO
+     END DO
+  END DO
+!
+! =========================================
+! calcul des tendances liees aux flux satures
+! =========================================
+  DO j=1,klev
+     DO i=1,klon
+        zmfa(i,j)=da(i,j)*(x(i,1)-x(i,j))
+     END DO
+  END DO
+  DO k=1,klev
+     DO j=1,klev
+        DO i=1,klon
+           zmfp(i,j)=zmfp(i,j)+phi(i,j,k)*(x(i,k)-x(i,j))
+        END DO
+     END DO
+  END DO
+  DO j=1,klev-1
+     DO i=1,klon
+        zmfu(i,j)=max(0.,upd(i,j+1)+dnd(i,j+1))*(x(i,j+1)-x(i,j))
+     END DO
+  END DO
+  DO j=2,klev
+     DO i=1,klon
+        zmfu(i,j)=zmfu(i,j)+min(0.,upd(i,j)+dnd(i,j))*(x(i,j)-x(i,j-1))
+     END DO
+  END DO
+
+! =========================================
+! calcul final des tendances
+! =========================================
+  DO k=1, klev
+     DO i=1, klon
+        dx(i,k)=(zmfd(i,k)+zmfu(i,k)       &
+             +zmfa(i,k)+zmfp(i,k))*pdtime  &
+             *RG/(paprs(i,k)-paprs(i,k+1)) 
+        !          print*,'dx',k,dx(i,k)
+     ENDDO
+  ENDDO
+
+! test de conservation du traceur
+!      conserv=0.
+!      DO k=1, klev
+!        DO i=1, klon
+!         conserv=conserv+dx(i,k)*   &
+!        (paprs(i,k)-paprs(i,k+1))/RG
+!        ENDDO
+!      ENDDO
+!      print *,'conserv',conserv
+     
+END SUBROUTINE cvltr
